WMarkDown.Converter.Modules = function(wmd, input){

    const self = this,
          excluded_keys = ["start", "get_keys"],
          modules_keys = [];
    let started = false;

    const construct = () => {

        const to_snake_fragment = string => string ? " " + string.toLowerCase() : "";

        Object.keys(WMarkDown.Converter.Modules).forEach(key => {
            if(!excluded_keys.includes(key)){

                const key = key.replace(/([A-Z]+)?([A-Z])/g, (...matches) => (" " + 
                    to_snake_fragment(matches[1]) + 
                    to_snake_fragment(matches[2])
                ));

                self[key] = new WMarkDown.Converter.Modules[key](wmd);
                !(self[key].pattern instanceof Array) && (self[key].pattern = [self[key].pattern]);

                modules_keys.push(key);

            };
        });

    };

    this.start = callback => {

        const end = status => typeof callback == "function" && callback(status)

        if(started){
            end(false);
            return false;
        };
        started = true;

        end(true);

        return true;
    };

    this.get_keys = () => [].concat(modules_keys);

    construct();

};